# Self-elevate the script if required
if (-Not ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] 'Administrator')) {
    if ([int](Get-CimInstance -Class Win32_OperatingSystem | Select-Object -ExpandProperty BuildNumber) -ge 6000) {
        $CommandLine = "-File `"" + $MyInvocation.MyCommand.Path + "`" " + $MyInvocation.UnboundArguments
        Start-Process -FilePath PowerShell.exe -Verb Runas -ArgumentList $CommandLine
    Exit
    }
}

# wTM-Removal.ps1
# Authors: pabumake,luzea
# Helpers: Harromann,Zuescho,XplLiciT,Cirno,Janmm14
# Origin: SemperVideo Community Discord
# Release: 2022-04-10 16:51

$global:checkProbabilitySum = 0

# Check for following System Paths

$winpath_systemfile = "C:\systemfile\"
$winpath_python3 = "C:\Windows\security\pywinvera"
$winpath_python3_sub = "C:\Windows\security\pywinveraa"

# Check if obs.log file exists -> Contains Encrypted Python File -> More investigation required
$filepath_crypted_python = "C:\systemfile\obs.log"


# Check for following Tasks in Sheduler
$taskpath_AppID = @('\Microsoft\Windows\AppID\','VerifiedCert')
$taskpath_ApplicationExp = @('\Microsoft\Windows\Application Experience\','Maintenance')
$taskpath_Services_0 = @('\Microsoft\Windows\Services\','CertPathCheck')
$taskpath_Services_1 = @('\Microsoft\Windows\Services\','CertPathw')
$taskpath_Servicing0 = @('\Microsoft\Windows\Servicing\','ComponentCleanup')
$taskpath_Servicing1 = @('\Microsoft\Windows\Servicing\','ServiceCleanup')
$taskpath_Shell = @('\Microsoft\Windows\Shell\','ObjectTask')
$taskpath_Clip = @('\Microsoft\Windows\Clip\','ServiceCleanup')

function Write-Log {
    [CmdletBinding()]
    param (
        [Parameter(Mandatory=$true, Position=0)]
        [String]
        $Message
    )

    process {
        if($Message.Contains('[!]')){
            Write-Host -ForegroundColor Red $Message
        } elseif($Message.Contains('[-]')){
            Write-Host -ForegroundColor Green $Message
        } else {
            Write-Host $Message
        }
        Add-Content -Path "$PSScriptRoot\Log.txt" -Value "$(Get-Date): $Message"
    }
}

function Get-SystemPaths ($winpath){
    # Check for C:\systemfile\
    if (Test-Path -Path $winpath){
        Write-Log "[!] Found $winpath."
        $global:checkProbabilitySum += 1
    } else {
    Write-Log "[*] Could not find $winpath"
    }
}

function Get-FilePaths ($winpath){
    # Check for C:\systemfile\
    if (Test-Path -Path $winpath -PathType Leaf){
        Write-Log "[!] Found $winpath. This file could contain major Payload."
        $global:checkProbabilitySum += 1
    } else {
    Write-Log "[*] Could not find $winpath"
    }
}

function Remove-SystemPaths($winpath){
    if (Test-Path -Path $winpath){
        try{
            Write-Log "[*] Removing $winpath"
            Remove-Item -Path $winpath -Recurse -Force
        }
        catch{
            Write-Log "[!] Could not delete $winpath"
            Write-Error $_
        }
    }
}

function Get-FromSchedulerTasks ($scheduledtasks){
    $fullschedulerpath = $scheduledtasks[0] + $scheduledtasks[1]
    if(Get-ScheduledTask -TaskPath $scheduledtasks[0] -TaskName $scheduledtasks[1] -ErrorAction "SilentlyContinue"){ #| Where {$_.TaskName -eq $scheduledtasks[1]}
        Write-Log "[!] Found $fullschedulerpath Raising Infection Probability by 1"
        $global:checkProbabilitySum += 1
    }
}

function Unregister-MalwareTasks ($scheduledtasks){
    $fullschedulerpath = $scheduledtasks[0] + $scheduledtasks[1]
    Write-Log "[*] Removing $fullschedulerpath"
    Unregister-ScheduledTask -TaskPath $scheduledtasks[0] -TaskName $scheduledtasks[1] -Confirm:$false -ErrorAction "SilentlyContinue"
}

function Get-RiskyInfectionState {
    $detectWinSystemLocale =  Get-WinSystemLocale | Select-Object -ExpandProperty Name
    if($detectWinSystemLocale -like "en-*"){
        Write-Log "[!] System is targeted by Malware. Use Remove Option to remove bad files/tasks"
        $global:checkProbabilitySum +=1
    } else {
        Write-Log "[-] System is NOT targeted by Malware. If no other files were found your probably save."
    }
}

Get-SystemPaths($winpath_systemfile)
Get-SystemPaths($winpath_python3)
Get-SystemPaths($winpath_python3_sub)
Get-FilePaths($filepath_crypted_python)

Get-FromSchedulerTasks($taskpath_AppID)
Get-FromSchedulerTasks($taskpath_ApplicationExp)
Get-FromSchedulerTasks($taskpath_Services_0)
Get-FromSchedulerTasks($taskpath_Services_1)
Get-FromSchedulerTasks($taskpath_Servicing0)
Get-FromSchedulerTasks($taskpath_Servicing1)
Get-FromSchedulerTasks($taskpath_Shell)
Get-FromSchedulerTasks($taskpath_Clip)
Get-RiskyInfectionState

if($global:checkProbabilitySum -gt 0){
    Write-Log "[!] Your System is at risk. We found $global:checkProbabilitySum entrys that match windowToolboxMalware."
    $removeMalware = Read-Host("Should we remove all folders and tasks connected with windowToolBox Malware? This requires Administrator Rights. (Y/N)")
    if($removeMalware -eq "Y" -or $removeMalware -eq "y"){
        Remove-SystemPaths($winpath_systemfile)
        Remove-SystemPaths($winpath_python3)
        Remove-SystemPaths($winpath_python3_sub)
        Unregister-MalwareTasks($taskpath_AppID)
        Unregister-MalwareTasks($taskpath_ApplicationExp)
        Unregister-MalwareTasks($taskpath_Services_0)
        Unregister-MalwareTasks($taskpath_Services_1)
        Unregister-MalwareTasks($taskpath_Servicing0)
        Unregister-MalwareTasks($taskpath_Servicing1)
        Unregister-MalwareTasks($taskpath_Shell)
        Unregister-MalwareTasks($taskpath_Clip)
        # Reestablish Windows Update and corresponding Services
        Set-Service -Name wuauserv -StartupType Manual
        Set-Service -Name bits -StartupType Manual
        Set-Service -Name cryptsvc -StartupType Automatic
        Write-Log "[!] To ensure everything is okay we recommend to run Windows Troubleshooting for Windows Update Services."
        Write-Log "[*] This window will close in 10 Seconds."
        Start-Sleep -Seconds 10

    }
}
else {
    Write-Log "[-] We could not find anything connected with windowToolxBox Malware. Recheck for new Version of this Script later."
    Write-Log "[*] This window will close in 10 Seconds."
    Start-Sleep -Seconds 10
}
